##=============================================================================
##
##	variant.S
##
##	MIPS variant code
##
##=============================================================================
#####ECOSGPLCOPYRIGHTBEGIN####
## -------------------------------------------
## This file is part of eCos, the Embedded Configurable Operating System.
## Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
##
## eCos is free software; you can redistribute it and/or modify it under
## the terms of the GNU General Public License as published by the Free
## Software Foundation; either version 2 or (at your option) any later version.
##
## eCos is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without even the implied warranty of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
## for more details.
##
## You should have received a copy of the GNU General Public License along
## with eCos; if not, write to the Free Software Foundation, Inc.,
## 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
##
## As a special exception, if other files instantiate templates or use macros
## or inline functions from this file, or you compile this file and link it
## with other works to produce a work based on this file, this file does not
## by itself cause the resulting work to be covered by the GNU General Public
## License. However the source code for this file must still be made available
## in accordance with section (3) of the GNU General Public License.
##
## This exception does not invalidate any other reasons why a work based on
## this file might be covered by the GNU General Public License.
##
## Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
## at http://sources.redhat.com/ecos/ecos-license/
## -------------------------------------------
#####ECOSGPLCOPYRIGHTEND####
##=============================================================================

#include <pkgconf/system.h>	
#include <pkgconf/hal.h>

#ifdef CYGPKG_KERNEL
# include <pkgconf/kernel.h>	
#endif
			
#include <cyg/hal/arch.inc>	
	
FUNC_START(hal_dcache_inv_all)
    mfc0  a0, C0_STATUS
    mfc0  v0, C0_CCTL		// Read CCTL
    li	  a1, ~3
    and   a1, a1, a0
    mtc0  a1, C0_STATUS		// disable  int

    li    v1, ~(CCTL_DWBINV)
    and	  v1, v0, v1
    mtc0  v1, C0_CCTL
    ori	  v1, v1, (CCTL_DWBINV)   // 0 to 1 transition
    mtc0  v1, C0_CCTL
    mtc0  a0, C0_STATUS
    jr	  ra
    nop
FUNC_END(hal_dcache_inv_all)

FUNC_START(hal_icache_inv_all)
    mfc0  a0, C0_STATUS
    mfc0  v0, C0_CCTL		// Read CCTL
    li	  a1, ~3
    and   a1, a1, a0
    mtc0  a1, C0_STATUS		// disable  int

    li    v1, ~(CCTL_IINVAL)
    and	  v1, v0, v1
    mtc0  v1, C0_CCTL
    ori	  v1, v1, (CCTL_IINVAL)   // 0 to 1 transition
    mtc0  v1, C0_CCTL
    mtc0  a0, C0_STATUS
    jr	  ra
    nop
FUNC_END(hal_icache_inv_all)  

FUNC_START(hal_imem_fill)
    mfc0  v0, C0_CCTL		// Read CCTL
    li    v1, ~CCTL_IMEMFILL
    and	  v1, v0, v1
    mtc0  v1, C0_CCTL
    ori	  v1, v1, (CCTL_IMEMFILL)   // 0 to 1 transition
    mtc0  v1, C0_CCTL
    jr	  ra
    nop
FUNC_END(hal_imem_fill)

#if 1
//	.section ".vsr_table","a"
	.data
	.globl	hal_vsr_table

hal_vsr_table:	
	.long	__default_interrupt_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__default_exception_vsr	
	.long	__break_vsr_springboard	//9 break
	.rept	6
	.long	__default_exception_vsr	
	.endr
#endif
##-----------------------------------------------------------------------------
## end of variant.S
	
